const Mesa = require('vendor/Mesa.js');
const Shopify= require('vendor/Shopify.js');

/**
 * A Mesa Script exports a class with a script() method.
 */
module.exports = new class {

  /**
   * Mesa Script
   *
   * @param {object} payload The payload data
   * @param {object} context Additional context about this task
   */
  script = (payload, context) => {
    const vars = context.steps;

    let last_id = 99999999999999;
    if (typeof(vars.data_1[0]) != 'undefined') {
      last_id = vars.data_1[0].last_id;
    }

    for (let i = 0; i < vars.transform.max_pages; i++) {
      let response = Shopify.get('/admin/shopify_payments/payouts.json', {
        "query": "last_id=" + last_id + "&limit=100"
      }); 
      for (let payout of response.payouts) {
        Mesa.log.info("Handling " + payout.id);
        Mesa.output.send('data', payout);
        last_id = payout.id;
      }
    }

    // Don't send output since we're already done with that Mesa.output.next(payload);
  }
}
